using Radzen;
using CheckboxInGridcolumnForSqliteIntegerField.Components;
using Microsoft.EntityFrameworkCore;

var builder = WebApplication.CreateBuilder(args);
// Add services to the container.
builder.Services.AddRazorComponents().AddInteractiveServerComponents().AddHubOptions(options => options.MaximumReceiveMessageSize = 10 * 1024 * 1024);
builder.Services.AddControllers();
builder.Services.AddRadzenComponents();
builder.Services.AddRadzenCookieThemeService(options =>
{
    options.Name = "CheckboxInGridcolumnForSqliteIntegerFieldTheme";
    options.Duration = TimeSpan.FromDays(365);
});
builder.Services.AddHttpClient();
builder.Services.AddScoped<CheckboxInGridcolumnForSqliteIntegerField.Checkbox_in_gridcolumn_for_sqlite_integer_fieldService>();
builder.Services.AddDbContext<CheckboxInGridcolumnForSqliteIntegerField.Data.Checkbox_in_gridcolumn_for_sqlite_integer_fieldContext>(options =>
{
    options.UseSqlite(builder.Configuration.GetConnectionString("Checkbox_in_gridcolumn_for_sqlite_integer_fieldConnection"));
});
var app = builder.Build();
// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Error", createScopeForErrors: true);
    // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
    app.UseHsts();
}

app.UseHttpsRedirection();
app.MapControllers();
app.UseStaticFiles();
app.UseAntiforgery();
app.MapRazorComponents<App>().AddInteractiveServerRenderMode();
app.Run();