using System;
using System.Data;
using System.Linq;
using System.Linq.Dynamic.Core;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Text.Encodings.Web;
using Microsoft.AspNetCore.Components;
using Microsoft.EntityFrameworkCore;
using Radzen;

using CheckboxInGridcolumnForSqliteIntegerField.Data;

namespace CheckboxInGridcolumnForSqliteIntegerField
{
    public partial class Checkbox_in_gridcolumn_for_sqlite_integer_fieldService
    {
        Checkbox_in_gridcolumn_for_sqlite_integer_fieldContext Context
        {
           get
           {
             return this.context;
           }
        }

        private readonly Checkbox_in_gridcolumn_for_sqlite_integer_fieldContext context;
        private readonly NavigationManager navigationManager;

        public Checkbox_in_gridcolumn_for_sqlite_integer_fieldService(Checkbox_in_gridcolumn_for_sqlite_integer_fieldContext context, NavigationManager navigationManager)
        {
            this.context = context;
            this.navigationManager = navigationManager;
        }

        public void Reset() => Context.ChangeTracker.Entries().Where(e => e.Entity != null).ToList().ForEach(e => e.State = EntityState.Detached);

        public void ApplyQuery<T>(ref IQueryable<T> items, Query query = null)
        {
            if (query != null)
            {
                if (!string.IsNullOrEmpty(query.Filter))
                {
                    if (query.FilterParameters != null)
                    {
                        items = items.Where(query.Filter, query.FilterParameters);
                    }
                    else
                    {
                        items = items.Where(query.Filter);
                    }
                }

                if (!string.IsNullOrEmpty(query.OrderBy))
                {
                    items = items.OrderBy(query.OrderBy);
                }

                if (query.Skip.HasValue)
                {
                    items = items.Skip(query.Skip.Value);
                }

                if (query.Top.HasValue)
                {
                    items = items.Take(query.Top.Value);
                }
            }
        }


        public async Task ExportSessionToExcel(Query query = null, string fileName = null)
        {
            navigationManager.NavigateTo(query != null ? query.ToUrl($"export/checkbox_in_gridcolumn_for_sqlite_integer_field/session/excel(fileName='{(!string.IsNullOrEmpty(fileName) ? UrlEncoder.Default.Encode(fileName) : "Export")}')") : $"export/checkbox_in_gridcolumn_for_sqlite_integer_field/session/excel(fileName='{(!string.IsNullOrEmpty(fileName) ? UrlEncoder.Default.Encode(fileName) : "Export")}')", true);
        }

        public async Task ExportSessionToCSV(Query query = null, string fileName = null)
        {
            navigationManager.NavigateTo(query != null ? query.ToUrl($"export/checkbox_in_gridcolumn_for_sqlite_integer_field/session/csv(fileName='{(!string.IsNullOrEmpty(fileName) ? UrlEncoder.Default.Encode(fileName) : "Export")}')") : $"export/checkbox_in_gridcolumn_for_sqlite_integer_field/session/csv(fileName='{(!string.IsNullOrEmpty(fileName) ? UrlEncoder.Default.Encode(fileName) : "Export")}')", true);
        }

        partial void OnSessionRead(ref IQueryable<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session> items);

        public async Task<IQueryable<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session>> GetSession(Query query = null)
        {
            var items = Context.Session.AsQueryable();


            if (query != null)
            {
                if (!string.IsNullOrEmpty(query.Expand))
                {
                    var propertiesToExpand = query.Expand.Split(',');
                    foreach(var p in propertiesToExpand)
                    {
                        items = items.Include(p.Trim());
                    }
                }

                ApplyQuery(ref items, query);
            }

            OnSessionRead(ref items);

            return await Task.FromResult(items);
        }

        partial void OnSessionGet(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item);
        partial void OnGetSessionById(ref IQueryable<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session> items);


        public async Task<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session> GetSessionById(long id)
        {
            var items = Context.Session
                              .AsNoTracking()
                              .Where(i => i.Id == id);

 
            OnGetSessionById(ref items);

            var itemToReturn = items.FirstOrDefault();

            OnSessionGet(itemToReturn);

            return await Task.FromResult(itemToReturn);
        }

        partial void OnSessionCreated(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item);
        partial void OnAfterSessionCreated(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item);

        public async Task<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session> CreateSession(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session session)
        {
            OnSessionCreated(session);

            var existingItem = Context.Session
                              .Where(i => i.Id == session.Id)
                              .FirstOrDefault();

            if (existingItem != null)
            {
               throw new Exception("Item already available");
            }            

            try
            {
                Context.Session.Add(session);
                Context.SaveChanges();
            }
            catch
            {
                Context.Entry(session).State = EntityState.Detached;
                throw;
            }

            OnAfterSessionCreated(session);

            return session;
        }

        public async Task<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session> CancelSessionChanges(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item)
        {
            var entityToCancel = Context.Entry(item);
            if (entityToCancel.State == EntityState.Modified)
            {
              entityToCancel.CurrentValues.SetValues(entityToCancel.OriginalValues);
              entityToCancel.State = EntityState.Unchanged;
            }

            return item;
        }

        partial void OnSessionUpdated(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item);
        partial void OnAfterSessionUpdated(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item);

        public async Task<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session> UpdateSession(long id, CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session session)
        {
            OnSessionUpdated(session);

            var itemToUpdate = Context.Session
                              .Where(i => i.Id == session.Id)
                              .FirstOrDefault();

            if (itemToUpdate == null)
            {
               throw new Exception("Item no longer available");
            }
                
            var entryToUpdate = Context.Entry(itemToUpdate);
            entryToUpdate.CurrentValues.SetValues(session);
            entryToUpdate.State = EntityState.Modified;

            Context.SaveChanges();

            OnAfterSessionUpdated(session);

            return session;
        }

        partial void OnSessionDeleted(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item);
        partial void OnAfterSessionDeleted(CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session item);

        public async Task<CheckboxInGridcolumnForSqliteIntegerField.Models.Checkbox_in_gridcolumn_for_sqlite_integer_field.Session> DeleteSession(long id)
        {
            var itemToDelete = Context.Session
                              .Where(i => i.Id == id)
                              .FirstOrDefault();

            if (itemToDelete == null)
            {
               throw new Exception("Item no longer available");
            }

            OnSessionDeleted(itemToDelete);


            Context.Session.Remove(itemToDelete);

            try
            {
                Context.SaveChanges();
            }
            catch
            {
                Context.Entry(itemToDelete).State = EntityState.Unchanged;
                throw;
            }

            OnAfterSessionDeleted(itemToDelete);

            return itemToDelete;
        }
        }
}